aboutsummaryrefslogtreecommitdiff
path: root/contrib/kiss-owns
diff options
context:
space:
mode:
Diffstat (limited to 'contrib/kiss-owns')
-rwxr-xr-xcontrib/kiss-owns25
1 files changed, 25 insertions, 0 deletions
diff --git a/contrib/kiss-owns b/contrib/kiss-owns
new file mode 100755
index 0000000..249c52c
--- /dev/null
+++ b/contrib/kiss-owns
@@ -0,0 +1,25 @@
+#!/bin/sh -e
+#
+# kiss-owns - Check which package owns a file.
+
+# Strip 'KISS_ROOT' from the file path if passed and
+# follow symlinks.
+file=$(readlink -f "$KISS_ROOT/${1##$KISS_ROOT}")
+
+# Check if the file exists and exit if it is not.
+[ -f "$file" ] || {
+ printf '%s\n' "error: file '$1' doesn't exist." >&2
+ exit 1
+}
+
+# Print the full path to the manifest file which contains
+# the match to our search.
+pkg_owns=$(grep -lFx "${file##$KISS_ROOT}" \
+ "$KISS_ROOT/var/db/kiss/installed/"*/manifest)
+
+
+# Extract the package name from the path above.
+pkg_owns=${pkg_owns%/*}
+pkg_owns=${pkg_owns##*/}
+
+printf '%s\n' "[$pkg_owns] owns '$1'"